<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseApiController;
use App\Http\Base\BaseController;
use App\Http\Handler\CurlHandler;
use App\Http\Handler\SyncHandler;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\KapalService;
use App\Http\Validators\KapalValidator;

class KapalController extends BaseController
{
    protected $baseService;
    protected $validator;

    /**
     * Kapal constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new KapalService();
        $this->validator = new KapalValidator();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {            
            $this->baseService->store($request->all());
            if ($this->baseService->hasInternetConnection()) {                
                $syncHandler = new SyncHandler();
                $syncHandler->setUrl("http://localhost:8000/api/kapal");
                $syncHandler->setBody([
                    "namaKapal" => $request->input("namaKapal")
                ]);
                $syncHandler->sync();
            }
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/kapal")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "ID"
            , "namaKapal" => "Nama Kapal"
        ];
        $this->data["criteria"] = ["id" => "ID"
            , "namaKapal" => "Nama Kapal"
        ];
        $this->data["ordering"] = [
             "id:asc" => "ID &uarr;",
             "id:desc" => "ID &darr;",
            "kodeKapal:asc" => "Kode Organisasi &uarr;"
            , "kodeKapal:desc" => "Kode Organisasi &darr;"
            , "namaKapal:asc" => "Nama Organisasi &uarr;"
            , "namaKapal:desc" => "Nama Organisasi &darr;"
        ];
        $this->data["kapals"] = $this->baseService->paging($request->all());
        return view("modules.kapal.kapal_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["kapal"] = $this->baseService->show($id);
        return view("modules.kapal.kapal_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/kapal")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view("modules.kapal.kapal_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $this->data["kapal"] = $this->baseService->show($id);
        return view("modules.kapal.kapal_show", $this->data);
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


}